<script>
  // Imports
  import { scaleLinear, scaleOrdinal } from 'd3-scale';
  import { schemeDark2 } from 'd3-scale-chromatic';
  import { min, max, extent } from 'd3-array';
  import Axis from "./Axis.svelte"

  // Dimensions
  const width = 800;
  const height = 100;
  const margin = { top: 20, right: 5, bottom: 5, left: 5 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;
  const radius = 8;

  // Array
  const values = [
    { x: 2, y: 1, category: "cat1" },
    { x: 4, y: 2, category: "cat3" },
    { x: 6, y: 1, category: "cat2" },
    { x: 7, y: 3, category: "cat3" },
    { x: 9, y: 1, category: "cat2" }
  ];

  var x_values = values.map(function(elt) { return elt.x; });
  var y_values = values.map(function(elt) { return elt.y; });
  var c_values = values.map(function(elt) { return elt.category; });
  
  // scales
  let xScale = scaleLinear()
    .domain([0,max(x_values)])
    .range([0, innerWidth-radius]);
  let yScale = scaleLinear()
    .domain([0,max(y_values)])
    .range([innerHeight-radius, 0]);
  let cScale = scaleOrdinal()
    .domain(c_values)
    .range(schemeDark2)
  

</script>

<svg viewBox="0 0 {width} {height}">
  <g transform="translate({margin.left},{margin.top})">
    <Axis {innerHeight} margin={margin.bottom} scale={xScale} position="bottom" />
    <Axis {innerHeight} margin=20 scale={yScale} position="left" nbYTicks=4/>
    {#each values as value}
      <text x="{xScale(value.x)}" y="{yScale(value.y)-10}" class="valueLabel">{value.y}</text>
      <circle cx="{xScale(value.x)}" cy="{yScale(value.y)}" r="{radius}" fill={cScale(value.category)} />
    {/each}
  </g>
</svg>


<style>
  text {
    text-anchor: middle;
    font-size: small;
  }
</style>
